// cog_dpram

/*
-------------------------------------------------------------------------------
Copyright 2014 Parallax Inc.

This file is part of the hardware description for the Propeller 1 Design.

The Propeller 1 Design is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

The Propeller 1 Design is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
the Propeller 1 Design.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------
*/
// RR20141010	true dual port ram for cog

module cog_dpram
(
input				clk,
input				ena, ena_b,
input				w, w_b,
input		 [8:0]	a, a_b,
input		[31:0]	d, d_b,
output reg	[31:0]	q, q_b
);

// Declare the RAM variable 512 x 32 ram
//reg [511:0] [31:0] r;
reg [31:0] r [511:0];

always @(posedge clk)
begin
// Port A
	if (ena && w)
		r[a] <= d;
	if (ena)
		q <= r[a];
// Port B
	if (ena_b && w_b)
		r[a_b] <= d_b;
	if (ena_b)
		q_b <= r[a_b];
end

endmodule
